#include "delay.hpp"

Delay::Delay()
{
	// calibrate the delay object according
	// to the speed of the computer

	// wait for a system tick
	long count = DosTickCount();
	while (count == DosTickCount() )
	  ;
	count = DosTickCount();

	// count until the next tick
	long delay;
	for (delay = 0; ; delay++)
	  if (count != DosTickCount() ) break;

	// save the count
	one_millisecond = delay / 2;
}

void Delay::Wait(long delay)
{
	for (long time = 0; time < delay; time++)
	  DelayOneMillisecond();
}


void Delay::DelayOneMillisecond()
{
	for (int i = 0; i < one_millisecond; i++)
	  ;
}

long Delay::DosTickCount()
{
	REGS command, results;
	long time;

	command. x. ax = READ_BIOS_TICK_COUNT;
	int86(GET_BIOS_TICK_COUNT_INTERRUPT, 
	      &command, &results);
	time = results. x. cx;
	return  (time << 16) + results. x. dx;
}
